<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" cdata-section-elements="DataContent"/>
<xsl:template match="/xml">
<rdf:RDF xmlns:cim="http://iec.ch/TC57/CIM-generic#" 
	xmlns:dm="http://iec.ch/2002/schema/CIM_difference_model#" 
	xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" 
	xmlns:placeholder_sb="placeholder_website#"
	xml:base="placeholder_website" >
    <xsl:for-each select="asset">
        <xsl:comment> a <xsl:value-of select="type"/> segment - START </xsl:comment>
        <xsl:variable name = "typeName"><xsl:value-of select="type"/></xsl:variable>
        
        <xsl:element name="placeholder_sb:{$typeName}">
            <xsl:attribute name="rdf:ID"><xsl:value-of select="name"/></xsl:attribute>
            <cim:RSM_IdentifiedObject.name><xsl:value-of select="name"/></cim:RSM_IdentifiedObject.name>
            <cim:RSM_UnnamedObject.mrid><xsl:value-of select="name"/></cim:RSM_UnnamedObject.mrid>
            <cim:RSM_PhysicalEntity.TypeOfPhysicalEntity>WorkEquipment</cim:RSM_PhysicalEntity.TypeOfPhysicalEntity>
            <cim:RSM_WorkEquipment.TypeOfEquipment><xsl:value-of select="type"/></cim:RSM_WorkEquipment.TypeOfEquipment>
        </xsl:element>	
        <xsl:element name="cim:RSM_GeoSpacial">
            <xsl:attribute name="rdf:ID"><xsl:value-of select="name"/>-Location</xsl:attribute>
            <cim:RSM_IdentifiedObject.name><xsl:value-of select="name"/>-Location</cim:RSM_IdentifiedObject.name>
            <cim:RSM_UnnamedObject.description><xsl:value-of select="name"/>-Location</cim:RSM_UnnamedObject.description>
            <cim:RSM_Location.TypeOfLocation>ISO6709</cim:RSM_Location.TypeOfLocation>		
            <cim:RSM_GeoSpacial.InternalLocation> <xsl:value-of select="location"/></cim:RSM_GeoSpacial.InternalLocation>
            <xsl:element name="cim:RSM_Location.providesLocationOf_PhysicalEntity">
                <xsl:attribute name="rdf:resource">#<xsl:value-of select="name"/></xsl:attribute>
            </xsl:element>     
        </xsl:element>
        <xsl:comment> a <xsl:value-of select="type"/> segment - END </xsl:comment>
    </xsl:for-each>
    <xsl:for-each select="link">
        <xsl:comment> a Line from <xsl:value-of select="pipe"/> to <xsl:value-of select="junction"/> - START </xsl:comment>        
        <xsl:element name="cim:RSM_ConnectionPoint">
            <xsl:attribute name="rdf:ID"><xsl:value-of select="pipe"/>_<xsl:value-of select="pc_point"/></xsl:attribute>
            <cim:RSM_IdentifiedObject.name><xsl:value-of select="pipe"/>_<xsl:value-of select="pc_point"/></cim:RSM_IdentifiedObject.name>
            <cim:RSM_UnnamedObject.mrid><xsl:value-of select="pipe"/>_<xsl:value-of select="pc_point"/></cim:RSM_UnnamedObject.mrid>
            <xsl:element name="cim:RSM_ConnectionPoint.belongsTo_PhysicalEntity">
                <xsl:attribute name="rdf:resource">#<xsl:value-of select="pipe"/></xsl:attribute>
            </xsl:element>
            <xsl:element name="cim:ISO15926_ConnectionPoint.To_ConnectionNode">
                <xsl:attribute name="rdf:resource">#<xsl:value-of select="pipe"/>_<xsl:value-of select="junction"/>_CNode</xsl:attribute>
            </xsl:element>
        </xsl:element>
        <xsl:element name="cim:ISO15926_ConnectionNode">
            <xsl:attribute name="rdf:ID"><xsl:value-of select="pipe"/>_<xsl:value-of select="junction"/>_CNode</xsl:attribute>
            <cim:RSM_IdentifiedObject.name><xsl:value-of select="pipe"/>_<xsl:value-of select="junction"/>_CNode</cim:RSM_IdentifiedObject.name>
            <cim:RSM_UnnamedObject.mrid><xsl:value-of select="pipe"/>_<xsl:value-of select="junction"/>_CNode</cim:RSM_UnnamedObject.mrid>	
        </xsl:element>
        <xsl:element name="cim:RSM_ConnectionPoint">
            <xsl:attribute name="rdf:ID"><xsl:value-of select="junction"/>_<xsl:value-of select="jc_point"/></xsl:attribute>
            <cim:RSM_IdentifiedObject.name><xsl:value-of select="junction"/>_<xsl:value-of select="jc_point"/></cim:RSM_IdentifiedObject.name>
            <cim:RSM_UnnamedObject.mrid><xsl:value-of select="junction"/>_<xsl:value-of select="jc_point"/></cim:RSM_UnnamedObject.mrid>
            <xsl:element name="cim:RSM_ConnectionPoint.belongsTo_PhysicalEntity">
                <xsl:attribute name="rdf:resource">#<xsl:value-of select="junction"/></xsl:attribute>
            </xsl:element>
            <xsl:element name="cim:ISO15926_ConnectionPoint.To_ConnectionNode">
                <xsl:attribute name="rdf:resource">#<xsl:value-of select="pipe"/>_<xsl:value-of select="junction"/>_CNode</xsl:attribute>
            </xsl:element>            
        </xsl:element>
        <xsl:comment> a Line from <xsl:value-of select="pipe"/> to <xsl:value-of select="junction"/> - END </xsl:comment> 
    </xsl:for-each>
</rdf:RDF>
</xsl:template>
</xsl:stylesheet>
	
