-- DDL for the instantiation of the Water Information Hub (WIH) 2.0 Solution Database
-- Created by Yong Deng Hu on 02/23/2012

-- Database Name: WIHDB          
-- Database Manager Version: DB2/NT Version 9.7.3          
-- Database Codepage: 1252
-- Database Collating Sequence is: UNIQUE

-- Instructions: Prior to running this replace <DB account> and <password> by the name and password of a DB2 admininstration account.


--------------------------------------
-- Create schema WASTE_WATER
--------------------------------------
CREATE SCHEMA WASTE_WATER;


--------------------------------------
-- Table containing typical rainfall
-- and CSO overflow volume YTD
--------------------------------------
CREATE TABLE WASTE_WATER.TYPICAL_YEAR_STATS
   (DAY_OF_YEAR         INTEGER NOT NULL,
    CSO_VOLUME_IN_MG	DOUBLE NOT NULL,
	RAINFALL_IN_INCHES  DOUBLE NOT NULL,
	CSO_VOLUME_OFFSET   DOUBLE NOT NULL,	
	RAINFALL_OFFSET     DOUBLE NOT NULL)
 IN USERSPACE1; 

ALTER TABLE WASTE_WATER.TYPICAL_YEAR_STATS
    ADD CONSTRAINT "PK1" PRIMARY KEY
        (DAY_OF_YEAR);			


--------------------------------------
-- Table for rainfall tracking
-- (daily and YTD)
--------------------------------------
CREATE TABLE WASTE_WATER.KPI_RAINFALL
   (MEASVAL_ID          INTEGER NOT NULL,
    RAINFALL_TODAY 		DOUBLE NOT NULL,
    DAY_OF_YEAR    		INTEGER NOT NULL,
    RAINFALL_YTD		DOUBLE NOT NULL)
 IN USERSPACE1; 

ALTER TABLE WASTE_WATER.KPI_RAINFALL
    ADD CONSTRAINT "PK1" PRIMARY KEY
        (MEASVAL_ID);	

ALTER TABLE WASTE_WATER.KPI_RAINFALL 
    ADD CONSTRAINT "FK1" FOREIGN KEY
       (MEASVAL_ID)
    REFERENCES WIH.MEASUREMENT_VALUE
	   (MEASVAL_ID); 


--------------------------------------
-- Table for WWTP configuration
--------------------------------------
CREATE TABLE WASTE_WATER.KPI_WWTP_CONFIG
  (CONFIGKEY    VARCHAR(255) NOT NULL,
    CONFIGVALUE    VARCHAR(255) NOT NULL)
 IN USERSPACE1; 


