--***********************************************************************
--***** Note:
--***** 1. For the communication template to work, the following needs to be setup:
--*****     mail.smtp.host
--*****     mxe.adminEmail
--*****     Assign a user to the role who are the recipient of the communication template. (You need to know the login password of the user)
--***** 2. Enable mail logging:	
--*****     set "mail" logger's log Level to "DEBUG", select your appender.
--************************************************************************
set schema = 'MAXIMO';

-- **********************************create person groups to be used in ticket template **************************
	insert into persongroup(persongroupid, persongroup, description, langcode, hasld)
	values(persongroupseq.nextval, 'PLUSIWTO','Water Operator','EN',0);	
	
	insert into persongroup(persongroupid, persongroup, description, langcode, hasld)
	values(persongroupseq.nextval, 'PLUSIWTE','Water Executive','EN',0);	


-- ****************************************create roles to be used in workflow *******************************
    insert into maxrole(maxrole,description,isemaildataset,isbroadcast,maxroleid,type,value,langcode,hasld)
    values('PLUSIWTO','Water Operator',0,0,maxroleseq.nextval,'PERSONGROUP','PLUSIWTO','EN',0);
    
    insert into maxrole(maxrole,description,isemaildataset,isbroadcast,maxroleid,type,value,langcode,hasld)
    values('PLUSIWTE','Water Operator',0,0,maxroleseq.nextval,'PERSONGROUP','PLUSIWTE','EN',0);

    			    			    			   		
-- *******************************************create work flows ***********************************************  
-- Workflow PLUSIDWSOC
	insert into wfprocess (processname, description, enabled, processrev, changeby, changedate, migrated, objectname, active, wfprocessid, langcode, autoinitiate, hasld, deletable,gotoinstance,launchondemand)
	values ('PLUSIDWSOC', 'Dry weather sewer overflow confirm', 1, 1, 'MAXADMIN', current timestamp, 0, 'WOACTIVITY', 1, wfprocessseq.NEXTVAL, 'EN', 0, 0,0,0,0);

	insert into wfrevision (processrev, revision, synchronizeby, synchronizedate, processname, mainprocess, wfrevisionid)
	values (1, 1, 'MAXADMIN', sysdate, 'PLUSIDWSOC', 'PLUSIDWSOC', wfrevisionseq.nextval);

	insert into wfnode (nodeid, nodetype, xcoordinate, ycoordinate, title, description, processrev, processname, wfnodeid, langcode, hasld)
	values (1, 'START', 1, 1, 'START', 'START', 1, 'PLUSIDWSOC', NEXTVAL FOR wfnodeseq, 'EN', 0);
	insert into wfnode (nodeid, nodetype, xcoordinate, ycoordinate, title, description, processrev, processname, wfnodeid, langcode, hasld)
	values (2, 'STOP', 10, 1, 'STOP', 'STOP', 1, 'PLUSIDWSOC', NEXTVAL FOR wfnodeseq, 'EN', 0);
	insert into wfnode (nodeid, nodetype, xcoordinate, ycoordinate, title, description, processrev, processname, wfnodeid, langcode, hasld)
	values (3, 'TASK', 3, 1, 'VALIDATE', 'Dry weather sewer overflow confirm', 1, 'PLUSIDWSOC', NEXTVAL FOR wfnodeseq, 'EN', 0);
	insert into wfnode (nodeid, nodetype, xcoordinate, ycoordinate, title, description, processrev, processname, wfnodeid, langcode, hasld)
	values (4, 'INPUT', 5, 1, 'CONFIRM', 'Dry weather sewer overflow confirm', 1, 'PLUSIDWSOC', NEXTVAL FOR wfnodeseq, 'EN', 0);
	insert into wfnode (nodeid, nodetype, xcoordinate, ycoordinate, title, description, processrev, processname, wfnodeid, langcode, hasld)
	values (5, 'CONDITION', 2, 1, 'NOTCAN?', 'Activity not cancelled?', 1, 'PLUSIDWSOC', NEXTVAL FOR wfnodeseq, 'EN', 0);

	insert into wfaction (actionid, ownernodeid, membernodeid, action, instruction, processrev, ispositive, processname, wfactionid)
	values (7, 5, 2, '', 'STOP 2', 1, 0, 'PLUSIDWSOC', NEXTVAL FOR wfactionseq);
	insert into wfaction (actionid, ownernodeid, membernodeid, action, instruction, processrev, ispositive, processname, wfactionid, sequence)
	values (2, 4, 2, 'APPCOMP', 'Yes, I confirm the dry weather sewer overflow.', 1, 1, 'PLUSIDWSOC', NEXTVAL FOR wfactionseq,1);
	insert into wfaction (actionid, ownernodeid, membernodeid, action, instruction, processrev, ispositive, processname, wfactionid)
	values (5, 5, 3, '', 'Dry weather sewer overflow confirm.', 1, 1, 'PLUSIDWSOC', NEXTVAL FOR wfactionseq);
	insert into wfaction (actionid, ownernodeid, membernodeid, action, instruction, processrev, ispositive, processname, wfactionid)
	values (1, 3, 4, '', 'Confirm the dry weather sewer overflow.', 1, 1, 'PLUSIDWSOC', NEXTVAL FOR wfactionseq);
	insert into wfaction (actionid, ownernodeid, membernodeid, action, instruction, processrev, ispositive, processname, wfactionid, sequence)
	values (6, 4, 5, 'PLUSIACTCANC', 'No, I have not confirm the dry weather sewer overflow. - Cancel', 1, 1, 'PLUSIDWSOC', NEXTVAL FOR wfactionseq,3);
	insert into wfaction (actionid, ownernodeid, membernodeid, action, instruction, processrev, ispositive, processname, wfactionid)
	values (4, 1, 5, '', 'Activity not cancelled?', 1, 1, 'PLUSIDWSOC', NEXTVAL FOR wfactionseq);

	insert into wfcondition (nodeid, condition, processrev, processname, wfconditionid)
	values (5, ':status <>''CAN''', 1, 'PLUSIDWSOC', wfconditionseq.nextval);
	
	insert into wftask(nodeid, readonly,firstcomplete,app,timelimit,processrev,processname,wftaskid,calendarbased,displayone)
	values(3,0,1,'ACTIVITY',0,1,'PLUSIDWSOC',wftaskseq.nextval,0,1);

	insert into wfassignment(assignid,description,app,emailnotification,assignstatus,wfid,nodeid,processrev,processname,roleid,wfassignmentid,ownertable,langcode,calendarbased,HASLD,separategroups)
	values(1,'Dry weather sewer overflow confirm','ACTIVITY',0,'DEFAULT',0,3,1,'PLUSIDWSOC','PLUSIWTO',wfassignmentseq.nextval,'WOACTIVITY','EN',0,0,1);

	insert into wfinput(nodeid,processrev,processname,wfinputid,displayone)
	values(4,1,'PLUSIDWSOC',wfinputseq.nextval,0);

	insert into wfstart (nodeid, processrev, processname, wfstartid)
	values (1, 1, 'PLUSIDWSOC', wfstartseq.nextval); 

	insert into wfstop (nodeid, processrev, processname, wfstopid)
	values (2, 1, 'PLUSIDWSOC', wfstopseq.nextval);


-- Workflow PLUSIDWSOP
	insert into wfprocess (processname, description, enabled, processrev, changeby, changedate, migrated, objectname, active, wfprocessid, langcode, autoinitiate, hasld, deletable,gotoinstance,launchondemand)
	values ('PLUSIDWSOP', 'Dry weather sewer overflow prevented', 1, 1, 'MAXADMIN', current timestamp, 0, 'WOACTIVITY', 1, wfprocessseq.NEXTVAL, 'EN', 0, 0,0,0,0);

	insert into wfrevision (processrev, revision, synchronizeby, synchronizedate, processname, mainprocess, wfrevisionid)
	values (1, 1, 'MAXADMIN', sysdate, 'PLUSIDWSOP', 'PLUSIDWSOP', wfrevisionseq.nextval);

	insert into wfnode (nodeid, nodetype, xcoordinate, ycoordinate, title, description, processrev, processname, wfnodeid, langcode, hasld)
	values (1, 'START', 1, 1, 'START', 'START', 1, 'PLUSIDWSOP', NEXTVAL FOR wfnodeseq, 'EN', 0);
	insert into wfnode (nodeid, nodetype, xcoordinate, ycoordinate, title, description, processrev, processname, wfnodeid, langcode, hasld)
	values (2, 'STOP', 10, 1, 'STOP', 'STOP', 1, 'PLUSIDWSOP', NEXTVAL FOR wfnodeseq, 'EN', 0);
	insert into wfnode (nodeid, nodetype, xcoordinate, ycoordinate, title, description, processrev, processname, wfnodeid, langcode, hasld)
	values (3, 'TASK', 3, 1, 'VALIDATE', 'Dry weather sewer overflow prevented', 1, 'PLUSIDWSOP', NEXTVAL FOR wfnodeseq, 'EN', 0);
	insert into wfnode (nodeid, nodetype, xcoordinate, ycoordinate, title, description, processrev, processname, wfnodeid, langcode, hasld)
	values (4, 'INPUT', 5, 1, 'prevented', 'Dry weather sewer overflow prevented', 1, 'PLUSIDWSOP', NEXTVAL FOR wfnodeseq, 'EN', 0);
	insert into wfnode (nodeid, nodetype, xcoordinate, ycoordinate, title, description, processrev, processname, wfnodeid, langcode, hasld)
	values (5, 'CONDITION', 2, 1, 'NOTCAN?', 'Activity not cancelled?', 1, 'PLUSIDWSOP', NEXTVAL FOR wfnodeseq, 'EN', 0);

	insert into wfaction (actionid, ownernodeid, membernodeid, action, instruction, processrev, ispositive, processname, wfactionid)
	values (7, 5, 2, '', 'STOP 2', 1, 0, 'PLUSIDWSOP', NEXTVAL FOR wfactionseq);
	insert into wfaction (actionid, ownernodeid, membernodeid, action, instruction, processrev, ispositive, processname, wfactionid, sequence)
	values (2, 4, 2, 'APPCOMP', 'Yes, I prevented the dry weather sewer overflow.', 1, 1, 'PLUSIDWSOP', NEXTVAL FOR wfactionseq,1);
	insert into wfaction (actionid, ownernodeid, membernodeid, action, instruction, processrev, ispositive, processname, wfactionid)
	values (5, 5, 3, '', 'Dry weather sewer overflow prevented.', 1, 1, 'PLUSIDWSOP', NEXTVAL FOR wfactionseq);
	insert into wfaction (actionid, ownernodeid, membernodeid, action, instruction, processrev, ispositive, processname, wfactionid)
	values (1, 3, 4, '', 'prevented the dry weather sewer overflow.', 1, 1, 'PLUSIDWSOP', NEXTVAL FOR wfactionseq);
	insert into wfaction (actionid, ownernodeid, membernodeid, action, instruction, processrev, ispositive, processname, wfactionid, sequence)
	values (6, 4, 5, 'PLUSIACTCANC', 'No, I have not prevented the dry weather sewer overflow. - Cancel', 1, 1, 'PLUSIDWSOP', NEXTVAL FOR wfactionseq,3);
	insert into wfaction (actionid, ownernodeid, membernodeid, action, instruction, processrev, ispositive, processname, wfactionid)
	values (4, 1, 5, '', 'Activity not cancelled?', 1, 1, 'PLUSIDWSOP', NEXTVAL FOR wfactionseq);

	insert into wfcondition (nodeid, condition, processrev, processname, wfconditionid)
	values (5, ':status <>''CAN''', 1, 'PLUSIDWSOP', wfconditionseq.nextval);
	
	insert into wftask(nodeid, readonly,firstcomplete,app,timelimit,processrev,processname,wftaskid,calendarbased,displayone)
	values(3,0,1,'ACTIVITY',0,1,'PLUSIDWSOP',wftaskseq.nextval,0,1);

	insert into wfassignment(assignid,description,app,emailnotification,assignstatus,wfid,nodeid,processrev,processname,roleid,wfassignmentid,ownertable,langcode,calendarbased,HASLD,separategroups)
	values(1,'Dry weather sewer overflow prevented','ACTIVITY',0,'DEFAULT',0,3,1,'PLUSIDWSOP','PLUSIWTO',wfassignmentseq.nextval,'WOACTIVITY','EN',0,0,1);

	insert into wfinput(nodeid,processrev,processname,wfinputid,displayone)
	values(4,1,'PLUSIDWSOP',wfinputseq.nextval,0);

	insert into wfstart (nodeid, processrev, processname, wfstartid)
	values (1, 1, 'PLUSIDWSOP', wfstartseq.nextval); 

	insert into wfstop (nodeid, processrev, processname, wfstopid)
	values (2, 1, 'PLUSIDWSOP', wfstopseq.nextval);
